Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 1 | #!/bin/sh |
| 2 | # |
| 3 | # Copyright (c) 2012, Intel Corporation. |
| 4 | # All rights reserved. |
| 5 | # |
| 6 | # This program is free software; you can redistribute it and/or modify |
| 7 | # it under the terms of the GNU General Public License as published by |
| 8 | # the Free Software Foundation; either version 2 of the License, or |
| 9 | # (at your option) any later version. |
| 10 | # |
| 11 | # This program is distributed in the hope that it will be useful, |
| 12 | # but WITHOUT ANY WARRANTY; without even the implied warranty of |
| 13 | # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See |
| 14 | # the GNU General Public License for more details. |
| 15 | # |
| 16 | # You should have received a copy of the GNU General Public License |
| 17 | # along with this program; if not, write to the Free Software |
| 18 | # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA |
| 19 | # |
| 20 | |
| 21 | LANG=C |
| 22 | |
| 23 | # Set to 1 to enable additional output |
| 24 | DEBUG=0 |
| 25 | OUT="/dev/null" |
| 26 | |
| 27 | # |
| 28 | # Defaults |
| 29 | # |
| 30 | # 20 Mb for the boot partition |
| 31 | BOOT_SIZE=20 |
| 32 | # 5% for swap |
| 33 | SWAP_RATIO=5 |
| 34 | |
| 35 | # Cleanup after die() |
| 36 | cleanup() { |
| 37 | debug "Syncing and unmounting devices" |
| 38 | # Unmount anything we mounted |
| 39 | unmount $ROOTFS_MNT || error "Failed to unmount $ROOTFS_MNT" |
| 40 | unmount $BOOTFS_MNT || error "Failed to unmount $BOOTFS_MNT" |
| 41 | unmount $HDDIMG_ROOTFS_MNT || error "Failed to unmount $HDDIMG_ROOTFS_MNT" |
| 42 | unmount $HDDIMG_MNT || error "Failed to unmount $HDDIMG_MNT" |
| 43 | |
| 44 | # Remove the TMPDIR |
| 45 | debug "Removing temporary files" |
| 46 | if [ -d "$TMPDIR" ]; then |
| 47 | rm -rf $TMPDIR || error "Failed to remove $TMPDIR" |
| 48 | fi |
| 49 | } |
| 50 | |
| 51 | trap 'die "Signal Received, Aborting..."' HUP INT TERM |
| 52 | |
| 53 | # Logging routines |
| 54 | WARNINGS=0 |
| 55 | ERRORS=0 |
| 56 | CLEAR="$(tput sgr0)" |
| 57 | INFO="$(tput bold)" |
| 58 | RED="$(tput setaf 1)$(tput bold)" |
| 59 | GREEN="$(tput setaf 2)$(tput bold)" |
| 60 | YELLOW="$(tput setaf 3)$(tput bold)" |
| 61 | info() { |
| 62 | echo "${INFO}$1${CLEAR}" |
| 63 | } |
| 64 | error() { |
| 65 | ERRORS=$((ERRORS+1)) |
| 66 | echo "${RED}$1${CLEAR}" |
| 67 | } |
| 68 | warn() { |
| 69 | WARNINGS=$((WARNINGS+1)) |
| 70 | echo "${YELLOW}$1${CLEAR}" |
| 71 | } |
| 72 | success() { |
| 73 | echo "${GREEN}$1${CLEAR}" |
| 74 | } |
| 75 | die() { |
| 76 | error "$1" |
| 77 | cleanup |
| 78 | exit 1 |
| 79 | } |
| 80 | debug() { |
| 81 | if [ $DEBUG -eq 1 ]; then |
| 82 | echo "$1" |
| 83 | fi |
| 84 | } |
| 85 | |
| 86 | usage() { |
| 87 | echo "Usage: $(basename $0) [-v] DEVICE HDDIMG TARGET_DEVICE" |
| 88 | echo " -v: Verbose debug" |
| 89 | echo " DEVICE: The device to write the image to, e.g. /dev/sdh" |
| 90 | echo " HDDIMG: The hddimg file to generate the efi disk from" |
| 91 | echo " TARGET_DEVICE: The device the target will boot from, e.g. /dev/mmcblk0" |
| 92 | } |
| 93 | |
| 94 | image_details() { |
| 95 | IMG=$1 |
| 96 | info "Image details" |
| 97 | echo " image: $(stat --printf '%N\n' $IMG)" |
| 98 | echo " size: $(stat -L --printf '%s bytes\n' $IMG)" |
| 99 | echo " modified: $(stat -L --printf '%y\n' $IMG)" |
| 100 | echo " type: $(file -L -b $IMG)" |
| 101 | echo "" |
| 102 | } |
| 103 | |
| 104 | device_details() { |
| 105 | DEV=$1 |
| 106 | BLOCK_SIZE=512 |
| 107 | |
| 108 | info "Device details" |
| 109 | echo " device: $DEVICE" |
| 110 | if [ -f "/sys/class/block/$DEV/device/vendor" ]; then |
| 111 | echo " vendor: $(cat /sys/class/block/$DEV/device/vendor)" |
| 112 | else |
| 113 | echo " vendor: UNKOWN" |
| 114 | fi |
| 115 | if [ -f "/sys/class/block/$DEV/device/model" ]; then |
| 116 | echo " model: $(cat /sys/class/block/$DEV/device/model)" |
| 117 | else |
| 118 | echo " model: UNKNOWN" |
| 119 | fi |
| 120 | if [ -f "/sys/class/block/$DEV/size" ]; then |
| 121 | echo " size: $(($(cat /sys/class/block/$DEV/size) * $BLOCK_SIZE)) bytes" |
| 122 | else |
| 123 | echo " size: UNKNOWN" |
| 124 | fi |
| 125 | echo "" |
| 126 | } |
| 127 | |
| 128 | unmount_device() { |
| 129 | grep -q $DEVICE /proc/mounts |
| 130 | if [ $? -eq 0 ]; then |
| 131 | warn "$DEVICE listed in /proc/mounts, attempting to unmount" |
| 132 | umount $DEVICE* 2>/dev/null |
| 133 | return $? |
| 134 | fi |
| 135 | return 0 |
| 136 | } |
| 137 | |
| 138 | unmount() { |
| 139 | if [ "$1" = "" ] ; then |
| 140 | return 0 |
| 141 | fi |
| 142 | grep -q $1 /proc/mounts |
| 143 | if [ $? -eq 0 ]; then |
| 144 | debug "Unmounting $1" |
| 145 | umount $1 |
| 146 | return $? |
| 147 | fi |
| 148 | return 0 |
| 149 | } |
| 150 | |
| 151 | # |
| 152 | # Parse and validate arguments |
| 153 | # |
| 154 | if [ $# -lt 3 ] || [ $# -gt 4 ]; then |
Patrick Williams | d7e9631 | 2015-09-22 08:09:05 -0500 | [diff] [blame] | 155 | if [ $# -eq 1 ]; then |
| 156 | AVAILABLE_DISK=`lsblk | grep "disk" | cut -f 1 -d " "` |
| 157 | X=0 |
| 158 | for disk in `echo $AVAILABLE_DISK`; do |
| 159 | mounted=`lsblk /dev/$disk | awk {'print $7'} | sed "s/MOUNTPOINT//"` |
| 160 | if [ -z "$mounted" ]; then |
| 161 | UNMOUNTED_AVAILABLES="$UNMOUNTED_AVAILABLES /dev/$disk" |
| 162 | info "$X - /dev/$disk" |
| 163 | X=`expr $X + 1` |
| 164 | fi |
| 165 | done |
| 166 | if [ $X -eq 0 ]; then |
| 167 | die "No unmounted device found." |
| 168 | fi |
| 169 | read -p "Choose unmounted device number: " DISK_NUMBER |
| 170 | X=0 |
| 171 | for line in `echo $UNMOUNTED_AVAILABLES`; do |
| 172 | if [ $DISK_NUMBER -eq $X ]; then |
| 173 | DISK_TO_BE_FLASHED=$line |
| 174 | break |
| 175 | else |
| 176 | X=`expr $X + 1` |
| 177 | fi |
| 178 | done |
| 179 | if [ -z "$DISK_TO_BE_FLASHED" ]; then |
| 180 | die "Option \"$DISK_NUMBER\" is invalid. Choose a valid option" |
| 181 | else |
| 182 | if [ -z `echo $DISK_TO_BE_FLASHED | grep "mmc"` ]; then |
| 183 | TARGET_TO_BE_BOOT="/dev/sda" |
| 184 | else |
| 185 | TARGET_TO_BE_BOOT="/dev/mmcblk0" |
| 186 | fi |
| 187 | fi |
| 188 | echo "" |
| 189 | echo "Choose a name of the device that will be boot from" |
| 190 | echo -n "Recommended name is: " |
| 191 | info "$TARGET_TO_BE_BOOT" |
| 192 | read -p "Is target device okay? [y/N]: " RESPONSE |
| 193 | if [ "$RESPONSE" != "y" ]; then |
| 194 | read -p "Choose target device name: " TARGET_TO_BE_BOOT |
| 195 | fi |
| 196 | echo "" |
| 197 | if [ -z "$TARGET_TO_BE_BOOT" ]; then |
| 198 | die "Error: choose a valid target name" |
| 199 | fi |
| 200 | else |
| 201 | usage |
| 202 | exit 1 |
| 203 | fi |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 204 | fi |
| 205 | |
| 206 | if [ "$1" = "-v" ]; then |
| 207 | DEBUG=1 |
| 208 | OUT="1" |
| 209 | shift |
| 210 | fi |
| 211 | |
Patrick Williams | d7e9631 | 2015-09-22 08:09:05 -0500 | [diff] [blame] | 212 | if [ -z "$AVAILABLE_DISK" ]; then |
| 213 | DEVICE=$1 |
| 214 | HDDIMG=$2 |
| 215 | TARGET_DEVICE=$3 |
| 216 | else |
| 217 | DEVICE=$DISK_TO_BE_FLASHED |
| 218 | HDDIMG=$1 |
| 219 | TARGET_DEVICE=$TARGET_TO_BE_BOOT |
| 220 | fi |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 221 | |
| 222 | LINK=$(readlink $DEVICE) |
| 223 | if [ $? -eq 0 ]; then |
| 224 | DEVICE="$LINK" |
| 225 | fi |
| 226 | |
| 227 | if [ ! -w "$DEVICE" ]; then |
| 228 | usage |
| 229 | if [ ! -e "${DEVICE}" ] ; then |
| 230 | die "Device $DEVICE cannot be found" |
| 231 | else |
| 232 | die "Device $DEVICE is not writable (need to run under sudo?)" |
| 233 | fi |
| 234 | fi |
| 235 | |
| 236 | if [ ! -e "$HDDIMG" ]; then |
| 237 | usage |
| 238 | die "HDDIMG $HDDIMG does not exist" |
| 239 | fi |
| 240 | |
| 241 | # |
| 242 | # Ensure the hddimg is not mounted |
| 243 | # |
| 244 | unmount "$HDDIMG" || die "Failed to unmount $HDDIMG" |
| 245 | |
| 246 | # |
| 247 | # Check if any $DEVICE partitions are mounted |
| 248 | # |
| 249 | unmount_device || die "Failed to unmount $DEVICE" |
| 250 | |
| 251 | # |
| 252 | # Confirm device with user |
| 253 | # |
| 254 | image_details $HDDIMG |
| 255 | device_details $(basename $DEVICE) |
| 256 | echo -n "${INFO}Prepare EFI image on $DEVICE [y/N]?${CLEAR} " |
| 257 | read RESPONSE |
| 258 | if [ "$RESPONSE" != "y" ]; then |
| 259 | echo "Image creation aborted" |
| 260 | exit 0 |
| 261 | fi |
| 262 | |
| 263 | |
| 264 | # |
| 265 | # Prepare the temporary working space |
| 266 | # |
| 267 | TMPDIR=$(mktemp -d mkefidisk-XXX) || die "Failed to create temporary mounting directory." |
| 268 | HDDIMG_MNT=$TMPDIR/hddimg |
| 269 | HDDIMG_ROOTFS_MNT=$TMPDIR/hddimg_rootfs |
| 270 | ROOTFS_MNT=$TMPDIR/rootfs |
| 271 | BOOTFS_MNT=$TMPDIR/bootfs |
| 272 | mkdir $HDDIMG_MNT || die "Failed to create $HDDIMG_MNT" |
| 273 | mkdir $HDDIMG_ROOTFS_MNT || die "Failed to create $HDDIMG_ROOTFS_MNT" |
| 274 | mkdir $ROOTFS_MNT || die "Failed to create $ROOTFS_MNT" |
| 275 | mkdir $BOOTFS_MNT || die "Failed to create $BOOTFS_MNT" |
| 276 | |
| 277 | |
| 278 | # |
| 279 | # Partition $DEVICE |
| 280 | # |
| 281 | DEVICE_SIZE=$(parted -s $DEVICE unit mb print | grep ^Disk | cut -d" " -f 3 | sed -e "s/MB//") |
| 282 | # If the device size is not reported there may not be a valid label |
| 283 | if [ "$DEVICE_SIZE" = "" ] ; then |
| 284 | parted -s $DEVICE mklabel msdos || die "Failed to create MSDOS partition table" |
| 285 | DEVICE_SIZE=$(parted -s $DEVICE unit mb print | grep ^Disk | cut -d" " -f 3 | sed -e "s/MB//") |
| 286 | fi |
| 287 | SWAP_SIZE=$((DEVICE_SIZE*SWAP_RATIO/100)) |
| 288 | ROOTFS_SIZE=$((DEVICE_SIZE-BOOT_SIZE-SWAP_SIZE)) |
| 289 | ROOTFS_START=$((BOOT_SIZE)) |
| 290 | ROOTFS_END=$((ROOTFS_START+ROOTFS_SIZE)) |
| 291 | SWAP_START=$((ROOTFS_END)) |
| 292 | |
| 293 | # MMC devices use a partition prefix character 'p' |
| 294 | PART_PREFIX="" |
| 295 | if [ ! "${DEVICE#/dev/mmcblk}" = "${DEVICE}" ] || [ ! "${DEVICE#/dev/loop}" = "${DEVICE}" ]; then |
| 296 | PART_PREFIX="p" |
| 297 | fi |
| 298 | BOOTFS=$DEVICE${PART_PREFIX}1 |
| 299 | ROOTFS=$DEVICE${PART_PREFIX}2 |
| 300 | SWAP=$DEVICE${PART_PREFIX}3 |
| 301 | |
| 302 | TARGET_PART_PREFIX="" |
| 303 | if [ ! "${TARGET_DEVICE#/dev/mmcblk}" = "${TARGET_DEVICE}" ]; then |
| 304 | TARGET_PART_PREFIX="p" |
| 305 | fi |
| 306 | TARGET_ROOTFS=$TARGET_DEVICE${TARGET_PART_PREFIX}2 |
| 307 | TARGET_SWAP=$TARGET_DEVICE${TARGET_PART_PREFIX}3 |
| 308 | |
| 309 | echo "" |
| 310 | info "Boot partition size: $BOOT_SIZE MB ($BOOTFS)" |
| 311 | info "ROOTFS partition size: $ROOTFS_SIZE MB ($ROOTFS)" |
| 312 | info "Swap partition size: $SWAP_SIZE MB ($SWAP)" |
| 313 | echo "" |
| 314 | |
| 315 | # Use MSDOS by default as GPT cannot be reliably distributed in disk image form |
| 316 | # as it requires the backup table to be on the last block of the device, which |
| 317 | # of course varies from device to device. |
| 318 | |
| 319 | info "Partitioning installation media ($DEVICE)" |
| 320 | |
| 321 | debug "Deleting partition table on $DEVICE" |
| 322 | dd if=/dev/zero of=$DEVICE bs=512 count=2 >$OUT 2>&1 || die "Failed to zero beginning of $DEVICE" |
| 323 | |
| 324 | debug "Creating new partition table (MSDOS) on $DEVICE" |
| 325 | parted -s $DEVICE mklabel msdos >$OUT 2>&1 || die "Failed to create MSDOS partition table" |
| 326 | |
| 327 | debug "Creating boot partition on $BOOTFS" |
| 328 | parted -s $DEVICE mkpart primary 0% $BOOT_SIZE >$OUT 2>&1 || die "Failed to create BOOT partition" |
| 329 | |
| 330 | debug "Enabling boot flag on $BOOTFS" |
| 331 | parted -s $DEVICE set 1 boot on >$OUT 2>&1 || die "Failed to enable boot flag" |
| 332 | |
| 333 | debug "Creating ROOTFS partition on $ROOTFS" |
| 334 | parted -s $DEVICE mkpart primary $ROOTFS_START $ROOTFS_END >$OUT 2>&1 || die "Failed to create ROOTFS partition" |
| 335 | |
| 336 | debug "Creating swap partition on $SWAP" |
| 337 | parted -s $DEVICE mkpart primary $SWAP_START 100% >$OUT 2>&1 || die "Failed to create SWAP partition" |
| 338 | |
| 339 | if [ $DEBUG -eq 1 ]; then |
| 340 | parted -s $DEVICE print |
| 341 | fi |
| 342 | |
| 343 | |
| 344 | # |
| 345 | # Check if any $DEVICE partitions are mounted after partitioning |
| 346 | # |
| 347 | unmount_device || die "Failed to unmount $DEVICE partitions" |
| 348 | |
| 349 | |
| 350 | # |
| 351 | # Format $DEVICE partitions |
| 352 | # |
| 353 | info "Formatting partitions" |
| 354 | debug "Formatting $BOOTFS as vfat" |
| 355 | if [ ! "${DEVICE#/dev/loop}" = "${DEVICE}" ]; then |
| 356 | mkfs.vfat -I $BOOTFS -n "EFI" >$OUT 2>&1 || die "Failed to format $BOOTFS" |
| 357 | else |
| 358 | mkfs.vfat $BOOTFS -n "EFI" >$OUT 2>&1 || die "Failed to format $BOOTFS" |
| 359 | fi |
| 360 | |
| 361 | debug "Formatting $ROOTFS as ext3" |
| 362 | mkfs.ext3 -F $ROOTFS -L "ROOT" >$OUT 2>&1 || die "Failed to format $ROOTFS" |
| 363 | |
| 364 | debug "Formatting swap partition ($SWAP)" |
| 365 | mkswap $SWAP >$OUT 2>&1 || die "Failed to prepare swap" |
| 366 | |
| 367 | |
| 368 | # |
| 369 | # Installing to $DEVICE |
| 370 | # |
| 371 | debug "Mounting images and device in preparation for installation" |
| 372 | mount -o loop $HDDIMG $HDDIMG_MNT >$OUT 2>&1 || error "Failed to mount $HDDIMG" |
| 373 | mount -o loop $HDDIMG_MNT/rootfs.img $HDDIMG_ROOTFS_MNT >$OUT 2>&1 || error "Failed to mount rootfs.img" |
| 374 | mount $ROOTFS $ROOTFS_MNT >$OUT 2>&1 || error "Failed to mount $ROOTFS on $ROOTFS_MNT" |
| 375 | mount $BOOTFS $BOOTFS_MNT >$OUT 2>&1 || error "Failed to mount $BOOTFS on $BOOTFS_MNT" |
| 376 | |
| 377 | info "Preparing boot partition" |
| 378 | EFIDIR="$BOOTFS_MNT/EFI/BOOT" |
| 379 | cp $HDDIMG_MNT/vmlinuz $BOOTFS_MNT >$OUT 2>&1 || error "Failed to copy vmlinuz" |
| 380 | # Copy the efi loader and configs (booti*.efi and grub.cfg if it exists) |
| 381 | cp -r $HDDIMG_MNT/EFI $BOOTFS_MNT >$OUT 2>&1 || error "Failed to copy EFI dir" |
| 382 | # Silently ignore a missing gummiboot loader dir (we might just be a GRUB image) |
| 383 | cp -r $HDDIMG_MNT/loader $BOOTFS_MNT >$OUT 2>&1 |
| 384 | |
| 385 | # Update the boot loaders configurations for an installed image |
| 386 | # Remove any existing root= kernel parameters and: |
| 387 | # o Add a root= parameter with the target rootfs |
| 388 | # o Specify ro so fsck can be run during boot |
| 389 | # o Specify rootwait in case the target media is an asyncronous block device |
| 390 | # such as MMC or USB disks |
| 391 | # o Specify "quiet" to minimize boot time when using slow serial consoles |
| 392 | |
| 393 | # Look for a GRUB installation |
| 394 | GRUB_CFG="$EFIDIR/grub.cfg" |
| 395 | if [ -e "$GRUB_CFG" ]; then |
| 396 | info "Configuring GRUB" |
| 397 | # Delete the install entry |
| 398 | sed -i "/menuentry 'install'/,/^}/d" $GRUB_CFG |
| 399 | # Delete the initrd lines |
| 400 | sed -i "/initrd /d" $GRUB_CFG |
| 401 | # Delete any LABEL= strings |
| 402 | sed -i "s/ LABEL=[^ ]*/ /" $GRUB_CFG |
| 403 | |
| 404 | sed -i "s@ root=[^ ]*@ @" $GRUB_CFG |
| 405 | sed -i "s@vmlinuz @vmlinuz root=$TARGET_ROOTFS ro rootwait quiet @" $GRUB_CFG |
| 406 | fi |
| 407 | |
| 408 | # Look for a gummiboot installation |
| 409 | GUMMI_ENTRIES="$BOOTFS_MNT/loader/entries" |
| 410 | GUMMI_CFG="$GUMMI_ENTRIES/boot.conf" |
| 411 | if [ -d "$GUMMI_ENTRIES" ]; then |
| 412 | info "Configuring Gummiboot" |
| 413 | # remove the install target if it exists |
| 414 | rm $GUMMI_ENTRIES/install.conf >$OUT 2>&1 |
| 415 | |
| 416 | if [ ! -e "$GUMMI_CFG" ]; then |
| 417 | echo "ERROR: $GUMMI_CFG not found" |
| 418 | fi |
| 419 | |
| 420 | sed -i "/initrd /d" $GUMMI_CFG |
| 421 | sed -i "s@ root=[^ ]*@ @" $GUMMI_CFG |
| 422 | sed -i "s@options *LABEL=boot @options LABEL=Boot root=$TARGET_ROOTFS ro rootwait quiet @" $GUMMI_CFG |
| 423 | fi |
| 424 | |
| 425 | # Ensure we have at least one EFI bootloader configured |
| 426 | if [ ! -e $GRUB_CFG ] && [ ! -e $GUMMI_CFG ]; then |
| 427 | die "No EFI bootloader configuration found" |
| 428 | fi |
| 429 | |
| 430 | |
| 431 | info "Copying ROOTFS files (this may take a while)" |
| 432 | cp -a $HDDIMG_ROOTFS_MNT/* $ROOTFS_MNT >$OUT 2>&1 || die "Root FS copy failed" |
| 433 | |
| 434 | echo "$TARGET_SWAP swap swap defaults 0 0" >> $ROOTFS_MNT/etc/fstab |
| 435 | |
| 436 | # We dont want udev to mount our root device while we're booting... |
| 437 | if [ -d $ROOTFS_MNT/etc/udev/ ] ; then |
| 438 | echo "$TARGET_DEVICE" >> $ROOTFS_MNT/etc/udev/mount.blacklist |
| 439 | fi |
| 440 | |
| 441 | |
| 442 | # Call cleanup to unmount devices and images and remove the TMPDIR |
| 443 | cleanup |
| 444 | |
| 445 | echo "" |
| 446 | if [ $WARNINGS -ne 0 ] && [ $ERRORS -eq 0 ]; then |
| 447 | echo "${YELLOW}Installation completed with warnings${CLEAR}" |
| 448 | echo "${YELLOW}Warnings: $WARNINGS${CLEAR}" |
| 449 | elif [ $ERRORS -ne 0 ]; then |
| 450 | echo "${RED}Installation encountered errors${CLEAR}" |
| 451 | echo "${RED}Errors: $ERRORS${CLEAR}" |
| 452 | echo "${YELLOW}Warnings: $WARNINGS${CLEAR}" |
| 453 | else |
| 454 | success "Installation completed successfully" |
| 455 | fi |
| 456 | echo "" |